import heapq


def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u, v))
        edges.append((v, u))  # Граф неориентированный

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))

    def dijkstra(graph, start):
        distances = {node: float('inf') for node in graph}
        distances[start] = 0
        priority_queue = [(0, start)]

        while priority_queue:
            dist, current_node = heapq.heappop(priority_queue)

            if dist > distances[current_node]:
                continue

            for neighbor in graph.get(current_node, []):
                distance = dist + 1
                if distance < distances[neighbor]:
                    distances[neighbor] = distance
                    heapq.heappush(priority_queue, (distance, neighbor))
        return distances

    graph = {}
    for u, v in edges:
        graph.setdefault(u, []).append(v)

    protected_warehouses = set()
    for guard_warehouse, guard_endurance in guards:
        distances = dijkstra(graph, guard_warehouse)
        for warehouse, distance in distances.items():
            if distance <= guard_endurance:
                protected_warehouses.add(warehouse)

    protected_warehouses_list = sorted(list(protected_warehouses))
    print(len(protected_warehouses_list))
    if protected_warehouses_list:
        print(*protected_warehouses_list)


solve()